<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2008 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: search.inc.php xxxx 2008-10-04 00:00:00Z Zanix $
 * @link       http://www.wowroster.net
 * @package    Vault
 * @subpackage Search
*/

if( !defined('IN_ROSTER') )
{
	exit('Detected invalid access to this file!');
}

/**
 * Vault Search
 *
 * @package    Vault
 * @subpackage Search
 */
class vaultSearch
{
	var $options;
	var $result = array();
	var $result_count = 0;
	var $start_search;
	var $stop_search;
	var $time_search;
	var $open_table;
	var $close_table;
	var $search_url;
	var $data = array();    // Addon data

	// class constructor
	function vaultSearch()
	{
		global $roster;
		
		require_once (ROSTER_LIB . 'item.php');

		$this->open_table = '<th class="membersHeader ts_string">' . $roster->locale->act['item'] . '</th>'
						  . '<th class="membersHeader ts_string">' . $roster->locale->act['level'] . '</th>'
						  . '<th class="membersHeader ts_string">' . $roster->locale->act['name'] . '</th>'
						  . '<th class="membersHeaderRight ts_string">' . $roster->locale->act['page'] . '</th></tr>';
	}

	function search( $search , $limit=10 , $page=0 )
	{
		global $roster;
		$tab_name = array();
		
		// Get all the vault page names first
		$sql = "SELECT `item_slot`, `item_name` FROM `" . $roster->db->table('addons_vault_items') . "` WHERE `item_parent` = 'vault'";   
		$result = $roster->db->query($sql);
		$x = $roster->db->num_rows($result);
		while( $x > 0 )
		{ 
			$row = $roster->db->fetch($result);
			$tab_name[$row['item_slot']] = $row['item_name'];
			$x--;
		}
		$roster->db->free_result($result);
		
		// Search the items
		$first = $page * $limit;

		$sql = "SELECT `item_id`, `item_name`, `item_parent`, `item_color`, `item_id`, `item_texture`, `item_quantity`, `item_tooltip`,
					 `level`, `locale`, sum(item_quantity) AS total_quantity"
			 . " FROM `" . $roster->db->table('addons_vault_items') . "`"
			 . " WHERE (`item_parent` LIKE 'Tab%') AND ("
			  . "    `item_name` LIKE '%" . $search . "%'"
				. " OR `item_color` LIKE '%$search%'"
				. " OR `item_id` LIKE '%$search%'"
				. " OR `item_texture` LIKE '%$search%'"
				. " OR `item_quantity` LIKE '%$search%'"
				. " OR `item_tooltip` LIKE '%$search%'"
				. " OR `level` LIKE '%$search%')"
			 . " GROUP BY `item_name`"
			 . ( $limit > 0 ? " LIMIT $first," . $limit : '' ) . ';';

		// calculating the search time
		$this->start_search = format_microtime();

		$result = $roster->db->query($sql);

		$this->stop_search = format_microtime();
		$this->time_search = $this->stop_search - $this->start_search;

		$nrows = $roster->db->num_rows($result);
		$crows = 0;

		$x = ($limit > $nrows) ? $nrows : ($limit > 0 ? $limit : $nrows);
		if( $nrows > 0 )
		{
			while( $x > 0 )
			{
				$row = $roster->db->fetch($result);

				$row['item_quantity'] = $row['total_quantity']; // Totals quantity, found on all pages

				$icon = new item($row);
				
				$item['html'] = '<td class="SearchRowCell">' . $icon->out() . '</td>'
					  . '<td class="SearchRowCell">' . $icon->requires_level . '</td>'
					  . '<td class="SearchRowCell"><span style="color:#' . $icon->color . '">[' . $icon->name . ']</span></td>'
					  . '<td class="SearchRowCellRight">' . $tab_name[$row['item_parent']] . '</td>'; // A link to the vault perhaps ?

				$this->add_result($item);
				unset($item);

				$x--;
			}
		}
		$roster->db->free_result($result);
	}

	function add_result( $resultarray )
	{
		$this->result[$this->result_count++] = $resultarray;
	}
}
